=== debian/changelog ===
xen (4.21~rc1-1+deb13u3.2) trixie; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 421432b822184f9
    tools/libs/light: fix BAR memory address truncation-Fri 24 Oct 2025 05:21
  * XSA-475
    0017-x86-viridian-Enforce-bounds-check-in-vpmask_set.diff:This is XSA-475 / CVE-2025-58147.
    0018-x86-viridian-Enforce-bounds-check-in-send_ipi.diff:This is XSA-475 / CVE-2025-58148.
  * XSA-476
    0027-tools-libs-light-fix-BAR-memory-address-truncation.diff:This is XSA-476 / CVE-2025-58149.

 -- Mark Pryor <pryorm09@gmail.com>  Sat, 25 Oct 2025 09:30:00 -0700

xen (4.21~rc1-1+deb13u3.1) trixie; urgency=medium

  * HEAD @ d1478321eacbfca57c3
    Update Xen version to 4.21.0-rc1-Tue 7 Oct 2025 07:13
  * initial build of rc1, ported from bookworm
  * removed: qemu-xen-traditional
  * d/control: prefer libjson-c over yajl
  * tools/libacpi/Makefile: mk_dsdt, add --dm-version

 -- Mark Pryor <pryorm09@gmail.com>  Wed, 08 Oct 2025 17:02:57 -0700
